unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TForm3 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    RichEdit1: TRichEdit;
    Button3: TButton;
    procedure ComboBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TWay = record
    Parent: Pointer;
    Index: Integer;
    Length: Integer;
    Time, Value: Single;
    Ways: Array of Pointer;
  end;

  PWay = ^TWay;

var
  Form3: TForm3;
  Way: PWay;
  Best: TList;

implementation

{$R *.dfm}

uses Unit1;

procedure ClearWay(Way: PWay);
var I: Integer;
begin
  for I := 0 to High(Way.Ways) do ClearWay(Way.Ways[I]);
  Dispose(Way);
end;

function IsInWay(Way: PWay; Index: Integer): Boolean;
begin
  if Way = nil then
  begin
    Result := False;
    Exit;
  end;
  Result := (Way.Index = Index) or IsInWay(Way.Parent, Index);
end;

procedure FindRoads(R: PWay; I1, I2: Integer);
var I: Integer;
    W: PWay;
begin
  I := -1;
  with Form1.Map do
  repeat
    I := Form1.Map.FindRoad(I1, I2, I);

    if IsInWay(R, I) then Continue;

    if ((AnsiSameText(Road[I].FromCity, City[I1].Name)) and (AnsiSameText(Road[I].ToCity, City[I2].Name))) or
       ((AnsiSameText(Road[I].FromCity, City[I2].Name)) and (AnsiSameText(Road[I].ToCity, City[I1].Name))) then
    begin
      SetLength(R.Ways, Succ(Length(R.Ways)));
      New(W);
      R.Ways[High(R.Ways)] := W;
      W.Length := R.Length + Road[I].Length;
      W.Time := R.Time + Road[I].Length / Road[I].AvSpeed;
      W.Index := I;
      W.Parent := R;
      Best.Add(W);
    end
    else
    begin
      SetLength(R.Ways, Succ(Length(R.Ways)));
      New(W);
      R.Ways[High(R.Ways)] := W;
      W.Length := R.Length + Road[I].Length;
      W.Time := R.Time + Road[I].Length / Road[I].AvSpeed;
      W.Index := I;
      W.Parent := R;
      if AnsiSameText(Road[I].FromCity, City[I1].Name) then FindRoads(W, FindCity(Road[I].ToCity), I2)
      else FindRoads(W, FindCity(Road[I].FromCity), I2);
    end;
  until I = -1;
end;

procedure TForm3.ComboBox1Change(Sender: TObject);
var I: Integer;
    T: PWay;
begin
  if ComboBox1.ItemIndex = ComboBox2.ItemIndex then
    raise Exception.Create('Muste zadat dv rzn msta!');
  New(Way);

  try
    RichEdit1.Clear;
    Way.Index := -1;
    Way.Length := 0;
    Way.Time := 0;
    Way.Value := 0;
    Way.Parent := nil;
    Best.Clear;
    FindRoads(Way, ComboBox1.ItemIndex, ComboBox2.ItemIndex);

    RichEdit1.Lines.Add(IntToStr(Best.Count));
    for I := 0 to Pred(Best.Count) do
    begin
      T := Best.Items[I];
      repeat
        if T.Index > -1 then RichEdit1.Lines.Add(Form1.Map.Road[T.Index].FromCity + ' - ' + Form1.Map.Road[T.Index].ToCity);
        T := T.Parent;
      until T = nil;
    end;  
  finally
    ClearWay(Way);
  end;
end;

procedure TForm3.FormCreate(Sender: TObject);
begin
  Best := TList.Create;
end;

procedure TForm3.FormDestroy(Sender: TObject);
begin
  Best.Destroy;
end;

end.

